require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/tools/criticities', type: :request do
  # Tools::Criticity. As you add validations to Tools::Criticity, be sure to
  # adjust the attributes here as well.
  let(:valid_attributes) { {rca_id: rca.id, labels_config_id: config.id} }

  let(:invalid_attributes) { {rca_id: rca.id, labels_config_id: nil} }

  let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }
  let(:config) { FactoryBot.create(:labels_config) }

  before :each do
    user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id) # Meth::StepTool.first.id
    user.save!

    sign_in user
  end

  describe 'GET /index' do
    context 'without rca defined' do
      it 'renders a successful response' do
        get tools_criticities_url
        expect(response).to have_http_status(:redirect)
        expect(response).to redirect_to(rcas_path)
      end
    end

    context 'without step_tool defined' do
      it 'renders a successful response' do
        user.set_session(:active_step_tool, nil)
        get tools_criticities_url, params: {rca: rca.id}
        expect(response).to have_http_status(:redirect)
        expect(response).to redirect_to(rcas_path)
      end
    end

    context 'with rca & step_tool defined' do
      it 'renders a successful response' do
        get tools_criticities_url, params: {rca: rca.id}
        expect(response).to be_successful
      end
    end
  end

  # TODO: décommenter quand réalisé pour le rapport
  # describe 'GET /show' do
  #   it 'renders a successful response' do
  #     tools_criticity = Tools::Criticity.create! valid_attributes
  #     get tools_criticity_url(tools_criticity)
  #     expect(response).to be_successful
  #   end
  # end

  describe 'GET /new' do
    it 'renders a successful response with HTTP' do
      get new_tools_criticity_url, params: {tools_criticity: {rca_id: rca.id}}
      expect(response).to be_successful
    end
    it 'renders a successful response with JS' do
      get new_tools_criticity_url, params: {tools_criticity: {rca_id: rca.id}}, xhr: true
      expect(response).to be_successful
    end
  end

  # describe 'GET /edit' do
  #   it 'render a successful response' do
  #     tools_criticity = Tools::Criticity.create! valid_attributes
  #     get edit_tools_criticity_url(tools_criticity)
  #     expect(response).to be_successful
  #   end
  # end

  describe 'POST /create' do
    context 'with valid parameters' do
      it 'creates a new Tools::Criticity' do
        expect {
          post tools_criticities_url, params: { tools_criticity: valid_attributes }
        }.to change(Tools::Criticity, :count).by(1)
      end

      it 'redirects to the created tools_criticity' do
        post tools_criticities_url, params: { tools_criticity: valid_attributes }
        expect(response).to redirect_to(meth_step_tool_show_path(id: user.get_session(:active_step_tool), rca: rca))
      end
    end

    context 'with invalid parameters' do
      it 'does not create a new Tools::Criticity' do
        expect {
          post tools_criticities_url, params: { tools_criticity: invalid_attributes }
        }.to change(Tools::Criticity, :count).by(0)
      end

      it 'renders a successful response (i.e. to display the new template)' do
        post tools_criticities_url, params: { tools_criticity: invalid_attributes }
        expect(response).to be_successful
      end
    end
  end

  describe 'PATCH /update : update and calculate' do
    before :each do
      @criticity = Tools::Criticity.create! valid_attributes
      cr1 = FactoryBot.create(:labels_criterium, config_id: config.id, internal_name: 'CR_1')
      cr2 = FactoryBot.create(:labels_criterium, config_id: config.id, internal_name: 'CR_2')
      cr3 = FactoryBot.create(:labels_criterium, config_id: config.id, internal_name: 'CR_3')
      lbv1 = FactoryBot.create(:labels_value, criterium_id: cr1.id, value: 1)
      lbv2 = FactoryBot.create(:labels_value, criterium_id: cr2.id, value: 2)
      lbv3 = FactoryBot.create(:labels_value, criterium_id: cr3.id, value: 3)

      @criticity.save!
      @criticity.create_criticity_values

      @criticity.criticity_values.where(labels_criterium_id: cr1.id).first.update(labels_value: lbv1)
      @criticity.criticity_values.where(labels_criterium_id: cr2.id).first.update(labels_value: lbv2)
      @criticity.criticity_values.where(labels_criterium_id: cr3.id).first.update(labels_value: lbv3)
    end

    context 'with valid parameters' do
      let(:valid_formula) { {formula: 'CR_1 + 2*CR_2 + 3*CR_3'} }
      let(:invalid_formula) { {formula: 'Toto + truc*CR_2 + 3*CR_3'} }

      it 'updates the requested tools_criticity and save the result' do
        config.update(valid_formula)
        tools_criticity = @criticity
        patch tools_criticity_url(tools_criticity), params: { tools_criticity: valid_attributes }, xhr: true
        tools_criticity.reload
        expect(tools_criticity.value).to eq 14
      end

      it 'render a successfull JS response' do
        tools_criticity = Tools::Criticity.create! valid_attributes
        patch tools_criticity_url(tools_criticity), params: { tools_criticity: valid_attributes }, xhr: true
        tools_criticity.reload
        expect(response).to be_successful
      end

      context 'with invalid formula' do
        it 'renders a successful response (i.e. to display the edit template)' do
          config.update(invalid_formula)
          tools_criticity = @criticity
          patch tools_criticity_url(tools_criticity), params: { tools_criticity: valid_attributes }, xhr: true
          tools_criticity.reload
          expect(tools_criticity.value).to eq nil
          expect(response).to be_successful
        end
      end
    end

    context 'with invalid parameters' do
      it 'redirect to criticity index' do
        tools_criticity = Tools::Criticity.create! valid_attributes
        patch tools_criticity_url(tools_criticity), params: { tools_criticity: invalid_attributes }
        expect(response).to redirect_to(meth_step_tool_show_path(id: user.get_session(:active_step_tool), rca: rca))
      end
    end
  end

  describe 'DELETE /destroy' do
    it 'destroys the requested tools_criticity' do
      tools_criticity = Tools::Criticity.create! valid_attributes
      expect {
        delete tools_criticity_url(tools_criticity)
      }.to change(Tools::Criticity, :count).by(-1)
    end

    it 'redirects to the tools_criticities list' do
      tools_criticity = Tools::Criticity.create! valid_attributes
      delete tools_criticity_url(tools_criticity)
      expect(response).to redirect_to(meth_step_tool_show_path(id: user.get_session(:active_step_tool), rca: rca))
    end
  end
end
